                     
void setup()
    {
      
      size(1200,800);
      background(255);
      strokeWeight(0.5);
      
      
      // loading a table in processing "myTable"
      myTable = loadTable( "SumByWeekDays.csv","header");
      
      //copying all the values into a 2D array of integers
       for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {                 
                  myArray[i][j] =  myTable.getInt( j,i); 
                }
          }
          
          
      //////////////////////////////////////////////////////////////////////////////////      
      /*
      //first we will be setting up the row sums to zero
      
      for ( int  i = 0 ;i < rows ; i++)
          sumOfRows[i] = 0 ;
     
     // supping up all the values for a particular row
     
     for ( int  i = 0; i< rows ; i++)
         {
           for ( int j = 0 ; j< cols ; j++)
               {
                 sumOfRows[i] += myArray[i][j];    //+= adds myaArray value into sumOfRows
               }
         }
     
      // we will be using another array to keep track of the row changes that happen during reordering
      //right now they are being set from row 0.......6
     for ( int i = 0; i < rows ; i++)
         trackerOfRowChanges[i] = i;
         
     //creating a copy of it
     for ( int  i = 0 ; i< rows ; i++)    
          CopyOfSumOfRows[i] = sumOfRows[i];
      
     /* here is what we want to accompalish here:
        this algorithm is called bubble sort , for more details: http://en.wikipedia.org/wiki/Bubble_sort
        the idea is to swap values if a lower value is encountered in the array
        to make things complicated we will have to swap everything that is asscociated with row
        i.e the rowNumbers and the day asscociated for visualizzation
       
     for ( int  i = 0 ; i < rows; i++)
         {
           for ( int j = i+1 ; j < cols ; j++)
               {
                 
                 if ( CopyOfSumOfRows[i] > CopyOfSumOfRows[j])
                    {
                      
                     // switching numbers
                       float temp = CopyOfSumOfRows[i];
                       CopyOfSumOfRows[i] = CopyOfSumOfRows[j];
                       CopyOfSumOfRows[j] = temp;
                       
                     // tracking changes in rows
                       float tempRow = trackerOfRowChanges[i];
                       trackerOfRowChanges[i] = trackerOfRowChanges[j];
                       trackerOfRowChanges[j] = tempRow;
                     // swapping the order of the days as well                  
                       String tempDay = orderedDays [i];
                       orderedDays[i] = orderedDays [j];
                       orderedDays[j] = tempDay;
                       
                    }
               }
         }     
                 
      //once we have the new positions, we can create a new 2D array and store all the values into it.
      // lets call it rowWeightedArray
      for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {
                  
                  float pointerToCorrectRow =  trackerOfRowChanges[i];
                  rowWeightedArray[i][j] = myArray[int(pointerToCorrectRow)][j];
                                                   
                }
          }
      
      
      
      
      */

      
      //////////////////////////////////////////////////////////////////////////////////      
       // ok now lets arrange the array by rows
       
     //first we will be setting up the row sums to zero
      for ( int  i = 0 ; i< rows ; i++)
           sumOfRows[i] =0;
           
      // we will be using another array to keep track of the row changes that happen during reordering
      //right now they are being set from row 0.......6
      for ( int  i = 0 ; i< rows ; i++)
           trackerOfRowChanges[i] =i;     
           
      // summing up all the values for a particular row , mutiplying by columnWigths is optional
      for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {                 
                 sumOfRows[i] += myArray[i][j] * columnWeights[j]; 
                }
          }
        
      //creating a copy of it    
      for ( int  i = 0 ; i< rows ; i++)    
          CopyOfSumOfRows[i] = sumOfRows[i];
      
      //reordering the matrix
       /* here is what we want to accompalish here:
        this algorithm is called bubble sort , for more details: http://en.wikipedia.org/wiki/Bubble_sort
        the idea is to swap values if a lower value is encountered in the array
        to make things complicated we will have to swap everything that is asscociated with row
        i.e the rowNumbers and the day asscociated for visualization
        */
      for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = i+1; j< rows ; j++ )
                { 
                 // bubble sort 
                 if ( CopyOfSumOfRows[i] > CopyOfSumOfRows[j] )
                     {
                       // switching numbers
                       float temp = CopyOfSumOfRows[i];
                       CopyOfSumOfRows[i] = CopyOfSumOfRows[j];
                       CopyOfSumOfRows[j] = temp;
                       
                       // tracking changes in rows
                       float tempRow = trackerOfRowChanges[i];
                       trackerOfRowChanges[i] = trackerOfRowChanges[j];
                       trackerOfRowChanges[j] = tempRow;
                       
                       String tempDay = orderedDays [i];
                       orderedDays[i] = orderedDays [j];
                       orderedDays[j] = tempDay;
                       
                     }
                      
                 
                }
          }
     
       //once we have the new positions, we can create a new 2D array and store all the values into it.
      // lets call it rowWeightedArray
       for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {
                  
                  float pointerToCorrectRow =  trackerOfRowChanges[i];
                  rowWeightedArray[i][j] = myArray[int(pointerToCorrectRow)][j];
                                                   
                }
          }
          
    //////////////////////////////////////////////////////////////////////////////////      
    // ok now lets arrange the array by columns, the same process is repeated
       
    // initalizing weighted sums
      for ( int  i = 0 ; i< cols ; i++)
           sumOfColumns[i] =0;
      
      // initalizing column numbers
      for ( int  i = 0 ; i< cols ; i++)
           trackerOfColumnChanges[i] =i;     
           
      // weighting each column and summing it up
      for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {                 
                 sumOfColumns[j] += myArray[i][j] * rowWeights[i]; 
                }
          }
          
          
       // copying to a new column   
       for ( int  i = 0 ; i< cols ; i++)    
           CopyOfSumOfColumns[i] = sumOfColumns[i];
      
      //reordering the matrix, we perform bubble sort againg , but keep track of the columns this time
      for ( int  i = 0 ; i< cols ; i++ )
          {
            for ( int j = i+1; j< cols ; j++ )
                { 
                 // bubble sort 
                 if ( CopyOfSumOfColumns[i] > CopyOfSumOfColumns[j] )    //check if jth column value is greater than the ith one
                     {
                       // switching numbers
                       float temp = CopyOfSumOfColumns[i];
                       CopyOfSumOfColumns[i] = CopyOfSumOfColumns[j];
                       CopyOfSumOfColumns[j] = temp;
                       
                       // tracking changes in cols
                       float tempColumns = trackerOfColumnChanges[i];
                       trackerOfColumnChanges[i] = trackerOfColumnChanges[j];
                       trackerOfColumnChanges[j] = tempColumns;
                       
                       //swapping the strings for the years
                       String tempYears = orderedYears [i];
                       orderedYears[i] = orderedYears [j];
                       orderedYears[j] = tempYears;
                     }        
                }
          }   
          
     // creating new column weighted array base on the index ( trackerOfColumn)
       
       for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {
                  
                  int pointerToCorrectColumn =  int ( trackerOfColumnChanges[j] ) ;
                  columnWeightedArray[i][j] = rowWeightedArray[i][pointerToCorrectColumn];
                                                   
                }
          }
        
      
        // simple algo to find the maxCount    
        for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {
                  
                 if( maxCount < myArray[i][j])
                    maxCount = myArray[i][j];
         
                }
          }
   
    
    
    
    //end of setup 
    println("maxcount: "+ maxCount);
    
    }
 
